#include "check.h"
#include "usb.h"
#include "ui_check.h"
#include <QMessageBox>

check::check(QWidget *parent) :
    QWidget(parent),
    ui(new Ui::check)
{
    ui->setupUi(this);
}

check::~check()
{
    delete ui;
}

void check::on_pushButton_clicked()
{
    QString temp;
    int che_number = ui->check_box->currentIndex();
    int sector, st;
    temp = ui->sector_edit->text();
    sector = temp.toInt();
    st = hs_authentication(icdev, che_number, sector + 1);
    if(st != 0)
    {
        QMessageBox::information(this, "提示信息", "校验失败");
        return ;
    } else {
        flag = 0;
        this->close();
    }
}

