﻿#include "hs_108j.h"
#include "ui_hs_108j.h"
#include "usb.h"
#include <QDebug>
hs_108j::hs_108j(QWidget *parent) :
    QWidget(parent),
    ui(new Ui::hs_108j)
{
    ui->setupUi(this);
    //this->setStyleSheet("background-color: qlineargradient(spread:pad, x1:0, y1:0, x2:1, y2:0, stop:0 rgba(251,102,102, 200), stop:1 rgba(20,196,188, 210));");

}
static const char *g_Nation[] = {
    "错误",
    "汉族",
    "蒙古族",
    "回族",
    "藏族",
    "维吾尔族",
    "苗族",
    "彝族",
    "壮族",
    "布依族",
    "朝鲜族",
    "满族",
    "侗族",
    "瑶族",
    "白族",
    "土家族",
    "哈尼族",
    "哈萨克族",
    "傣族",
    "黎族",
    "傈傈族",
    "佤族",
    "畲族",
    "高山族",
    "拉祜族",
    "水族",
    "东乡族",
    "纳西族",
    "景颇族",
    "柯尔克孜族",
    "土族",
    "达翰尔族",
    "仫佬族",
    "羌族",
    "布朗族",
    "撒拉族",
    "毛南族",
    "仡佬族",
    "锡伯族",
    "阿昌族",
    "普米族",
    "塔吉克族",
    "怒族",
    "乌孜别克族",
    "俄罗斯族",
    "鄂温克族",
    "德昂族",
    "保安族",
    "裕固族",
    "京族",
    "塔塔尔族",
    "独龙族",
    "鄂伦春族",
    "赫哲族",
    "门巴族",
    "珞巴族",
    "基诺族",
    "其他"
};

hs_108j::~hs_108j()
{
    delete ui;
}

void hs_108j::on_bankbutton_clicked()
{
    QString temp;
    int ret = 0;
    dc_exit(icdev);
    icdev = dc_init(100, 115200);

    if ((long long) icdev == -1) {
        ui->Recv_Data->append(u8"请打开设备！");
        return;
    }
    char strOutput[64] = "\0";
//    ret = hs_GetBankAccountNumber(icdev,1,strOutput);//读取接触式的银行卡
    ret = dc_GetBankAccountNumber(icdev, 1, strOutput);
    if (ret != 0) {
        ui->Recv_Data->append("get bank card false!!!");
        printf("ret = %d\n", ret);
        return;
    }
    else {
        ui->Recv_Data->append("bank card is:");
        temp = strOutput;
        ui->Recv_Data->append(temp);
//        hs_beep(icdev, 10);
        dc_beep(icdev, 10);
    }
}


void hs_108j::on_pushButton_3_clicked()
{
    ui->Recv_Data->clear();
    ui->recvEdit->clear();;
    ui->resetEdit->clear();
    ui->Commnd->clear();
}

void hs_108j::on_pushButton_4_clicked()
{
    char data_buffer[1024] = {0};
    QString temp, text;
    int st = 0;
    dc_exit(icdev);
    icdev = dc_init(100, 115200);
    if ((long long) icdev == -1) {
        ui->Recv_Data->append(u8"请打开设备！");
        return;
    }
//    st = hs_read_4442_hex(icdev, 0, 256, (unsigned char *)data_buffer);
    st = dc_read_4442_hex(icdev, 0, 256, (unsigned char *)data_buffer);
    if (st != 0) {
        ui->Recv_Data->append(u8"4442卡读取错误，请确认卡类型\r\n");
        return;
    }
    temp = QString::fromUtf8(data_buffer, sizeof(data_buffer));
    ui->Recv_Data->append(temp);
//    hs_beep(icdev,10);
    dc_beep(icdev, 10);

}


void hs_108j::on_reset_clicked()
{
    int st = 0;
    QString temp;
    unsigned char rlen = 0;
    unsigned char snr[8] = "\0";
    char recv[128] = "\0";
    dc_exit(icdev);
    icdev = dc_init(100, 115200);
//    st = hs_cpureset_hex(icdev, &rlen, recv);
    st = dc_cpureset_hex(icdev, &rlen, recv);
    if (st < 0) {
        ui->resetEdit->setText(u8"复位失败");
        return;
    }
    temp = recv;
    ui->resetEdit->setText(temp);
}


void hs_108j::on_sendCommand_clicked()
{
    short  st = -1;
    int i = 0;
    unsigned char slen = 0,rlen = 0;
    dc_exit(icdev);
    icdev = dc_init(100, 115200);
    char recv_data[512] = "\0";
    QString temp = ui->Commnd->text();
    QByteArray text = temp.toLatin1();
    i = text.length();
    char *sendbuf = text.data();
    slen = (char) (i / 2);
//    st = hs_cpuapdu_hex(icdev, slen, sendbuf, &rlen, recv_data);
    st = dc_cpuapdu_hex(icdev, slen, sendbuf, &rlen, recv_data);
    if (st < 0) {
        ui->recvEdit->setText(u8"接受数据错误");
        return ;
    }
    temp = recv_data;
    ui->recvEdit->setText(temp);
    return;
}



void hs_108j::on_pushButton_clicked()
{
    char strOutput[64] = "\0";
    char pincode[64]= "\0";
    char cardtype[64]= "\0";
    char version[64]= "\0";
    char orgnum[64]= "\0";
    char starttime[64]= "\0";
    char endtime[64]= "\0";
    char cardnum[64]= "\0";
     unsigned char title[128], message[512];
     QString temp;

     printf("\n-------- SS Card Test --------\n");
     dc_exit(icdev);
     icdev = dc_init(100, 115200);
     unsigned char rlen=0;
     char sendbuff[64]="\0";
     char recvbuff[64]="\0";
     int st=0;
     st = dc_setcpu(icdev,0x0C);
     char logbuff[256]="\0";


     dc_SetCpuVoltage(icdev,0);
     st = dc_cpureset_hex(icdev,&rlen, recvbuff);
     if(st!=0)
     {
         //无卡
         dc_SetCpuVoltage(icdev,1);
         st = dc_cpureset_hex(icdev,&rlen, recvbuff);
         if(st!=0)
         {
             strcpy(logbuff,"复位失败无卡\n");
             return ;
         }
     }
     //选择社保环境
     memset(sendbuff,0,64);

     memcpy(sendbuff,"00A404000F7378312E73682EC9E7BBE1B1A3D5CF",40);
     st = dc_cpuapdusource_hex(icdev,20,sendbuff,&rlen,recvbuff);
     if(st!=0)
     {
         strcpy(logbuff,"社保环境应用失败\n");

         //return -12;
     }
     //choose of file 05
     memset(sendbuff,0,64);

     memcpy(sendbuff,"00A4020002EF05",14);
     st = dc_cpuapdusource_hex(icdev,7,sendbuff,&rlen,recvbuff);
     if(st!=0)
     {
         strcpy(logbuff,"05文件打开失败\n");
         return ;
     }
     memset(sendbuff,0,64);
     memcpy(sendbuff,"00B2010012",10);
     st = dc_cpuapdusource_hex(icdev,5,sendbuff,&rlen,recvbuff);
     if(st!=0)
     {
 //		strcpy(logbuff,"卡识别码读取失败\n");
 //		faddlog(logbuff);
     //	return -13;
     }
     rlen=rlen*2;
     strncpy(pincode,recvbuff,(rlen-4));
     pincode[rlen-4]='\0';
     memset(sendbuff,0,64);
     memcpy(sendbuff,"00B2020003",10);
     st = dc_cpuapdusource_hex(icdev,5,sendbuff,&rlen,recvbuff);
     if(st!=0)
     {
     //	strcpy(logbuff,"卡类别读取失败\n");
 //		faddlog(logbuff);
     //	return -14;
     }
     rlen=rlen*2;
     strncpy(cardtype,recvbuff,(rlen-4));
     cardtype[rlen-4]='\0';

     memset(sendbuff,0,64);
     memcpy(sendbuff,"00B2030006",10);
     st = dc_cpuapdusource_hex(icdev,5,sendbuff,&rlen,recvbuff);
     if(st!=0)
     {
         strcpy(logbuff,"卡规范读取失败\n");
     //	return -15;
     }
     rlen=rlen*2;
     strncpy(version,recvbuff,(rlen-4));
     version[rlen-4]='\0';

     memset(sendbuff,0,64);
     memcpy(sendbuff,"00B204000E",10);
     st = dc_cpuapdusource_hex(icdev,5,sendbuff,&rlen,recvbuff);
     if(st!=0)
     {
         strcpy(logbuff,"机构编码读取失败\n");

     //	return -16;
     }
     rlen=rlen*2;
     strncpy(orgnum,recvbuff,(rlen-4));
     orgnum[rlen-4]='\0';

     memset(sendbuff,0,64);
     memcpy(sendbuff,"00B2050006",10);
     st = dc_cpuapdusource_hex(icdev,5,sendbuff,&rlen,recvbuff);
     if(st!=0)
     {
         strcpy(logbuff,"发卡日期读取失败\n");
     //	return -17;
     }
     rlen=rlen*2;
     strncpy(starttime,recvbuff,(rlen-4));
     starttime[rlen-4]='\0';

     memset(sendbuff,0,64);
     memcpy(sendbuff,"00B2060006",10);
     st = dc_cpuapdusource_hex(icdev,5,sendbuff,&rlen,recvbuff);
     if(st!=0)
     {
         strcpy(logbuff,"有效日期读取失败\n");
     //	return -18;
     }
     rlen=rlen*2;
     strncpy(endtime,recvbuff,(rlen-4));
     endtime[rlen-4]='\0';

     memset(sendbuff,0,64);
     memcpy(sendbuff,"00B207000E",10);
     st = dc_cpuapdusource_hex(icdev,5,sendbuff,&rlen,recvbuff);
     if(st!=0)
     {
         strcpy(logbuff,"卡号读取失败\n");
     //	return -19;
     }
     rlen=rlen*2;
     strncpy(cardnum,recvbuff,(rlen-4));
     cardnum[rlen-4]='\0';
     char cardnumchange[128]= "\0";int len =0;
     a_hex((unsigned char*)&cardnum[2],(unsigned char*)cardnumchange,2);
     len=cardnumchange[0];
     if(len == 0) {
         ui->Recv_Data->append("read social card 05 error");
 //        hs_exit(icdev);
         dc_exit(icdev);
         return;
     }
 //    hs_a_hex((unsigned char*)&cardnum[4],(unsigned char*)cardnumchange,len*2);
     a_hex((unsigned char*)&cardnum[4],(unsigned char*)cardnumchange,2*len);
 //    hs_beep(icdev, 10);
     dc_beep(icdev, 10);
     cardnumchange[len]=0;
     temp = pincode;
     ui->Recv_Data->append(u8"卡识别码:");
     ui->Recv_Data->append(temp);
     temp = cardtype;
     ui->Recv_Data->append(u8"卡类型:");
     ui->Recv_Data->append(temp);
     temp = version;
     ui->Recv_Data->append(u8"卡规范版本:");
     ui->Recv_Data->append(temp);
     temp = orgnum;
     ui->Recv_Data->append(u8"初始化机构编号:");
     ui->Recv_Data->append(temp);
     temp = starttime;
     ui->Recv_Data->append(u8"发卡日期:");
     ui->Recv_Data->append(temp);
     temp = endtime;
     ui->Recv_Data->append(u8"有效日期:");
     ui->Recv_Data->append(temp);
     temp = cardnumchange;
     ui->Recv_Data->append(u8"卡号:");
     ui->Recv_Data->append(temp);






     dc_beep(icdev, 20);
}

void hs_108j::on_pushButton_2_clicked()
{
    char IDnum[64]= "\0";
    char name[64]= "\0";
    char exname[64]= "\0";
    char sex[64]= "\0";
    char nation[64]= "\0";
    char birthday[64]= "\0";
    char addr[64]= "\0";
    int st = 0;
    char strOutput[64] = "\0";
    QString temp, text;
    unsigned char rlen=0;
    char sendbuff[64]="\0";
    char recvbuff[64]="\0";
    char logbuff[256]="\0";
    st = dc_setcpu(icdev,0x0C);
    if(st!=0)
    {
        return ;
    }

    dc_SetCpuVoltage(icdev,0);
    st = dc_cpureset_hex(icdev,&rlen, recvbuff);
    if(st!=0)
    {
        //无卡
        dc_SetCpuVoltage(icdev,1);
        st = dc_cpureset_hex(icdev,&rlen, recvbuff);
        if(st!=0)
        {
            strcpy(logbuff,"复位失败无卡\n");
            return ;
        }
    }

    //选择社保环境
    memset(sendbuff,0,64);

    memcpy(sendbuff,"00A404000F7378312E73682EC9E7BBE1B1A3D5CF",40);
    st = dc_cpuapdusource_hex(icdev,20,sendbuff,&rlen,recvbuff);
    if(st!=0)
    {
        strcpy(logbuff,"社保环境应用失败\n");
        //return -12;
    }

    //choose of file 06
    memcpy(sendbuff,"00A4020002EF06",14);
    st = dc_cpuapdusource_hex(icdev,7,sendbuff,&rlen,recvbuff);
    if(st!=0)
    {
        strcpy(logbuff,"06文件打开失败\n");
        return;
    }
    memset(sendbuff,0,64);
    memcpy(sendbuff,"00B2080014",10);
    st = dc_cpuapdusource_hex(icdev,5,sendbuff,&rlen,recvbuff);
    if(st!=0)
    {
        strcpy(logbuff,"社会保障号码读取失败\n");
        return ;
    }
    rlen=rlen*2;
//	strncpy(IDnum,recvbuff,(rlen-4));
    recvbuff[rlen-4]='\0';


    //char IDnumchange[128]= "\0";
    int len =0;
    a_hex((unsigned char*)&recvbuff[2],(unsigned char*)IDnum,2);
    len=IDnum[0];

    if(len==0)
    {
        strcpy(logbuff,"社会保障号码长度错误\n");
        return ;//
    }

    a_hex((unsigned char*)&recvbuff[4],(unsigned char*)IDnum,len*2);
    IDnum[len]=0;

    memset(sendbuff,0,64);
    memcpy(sendbuff,"00B2090020",10);
    st = dc_cpuapdusource_hex(icdev,5,sendbuff,&rlen,recvbuff);
    if(st!=0)
    {
        strcpy(logbuff,"姓名读取失败\n");
        return ;
    }
    rlen=rlen*2;
    //strncpy(name,recvbuff,(rlen-4));
    recvbuff[rlen-4]='\0';

//	char namechange[128];
    a_hex((unsigned char*)&recvbuff[2],(unsigned char*)name,2);
    len=name[0];

    a_hex((unsigned char*)&recvbuff[4],(unsigned char*)name,len*2);
    name[len]=0;


    memset(sendbuff,0,64);
    memcpy(sendbuff,"00B24E0016",10);
    st = dc_cpuapdusource_hex(icdev,5,sendbuff,&rlen,recvbuff);
    if(st!=0)
    {
        strcpy(logbuff," 姓名扩展读取失败\n");
        return ;
    }
    rlen=rlen*2;
    strncpy(exname,recvbuff,(rlen-4));
    exname[rlen-4]='\0';

    memset(sendbuff,0,64);
    memcpy(sendbuff,"00B20A0003",10);
    st = dc_cpuapdusource_hex(icdev,5,sendbuff,&rlen,recvbuff);
    if(st!=0)
    {
        strcpy(logbuff,"性别读取失败\n");
        return;
    }
    rlen=rlen*2;
//	strncpy(sex,recvbuff,(rlen-4));
    recvbuff[rlen-4]='\0';
    const char *sexarry[] = {
    "男","女"};
        char sexchange[2];

    a_hex((unsigned char*)&recvbuff[4],(unsigned char*)sexchange,2);


strncpy(sex,sexarry[sexchange[0]-0x31],strlen(sexarry[sexchange[0]-0x31]));

    memset(sendbuff,0,64);
    memcpy(sendbuff,"00B20B0003",10);
    st = dc_cpuapdusource_hex(icdev,5,sendbuff,&rlen,recvbuff);
    if(st!=0)
    {
        strcpy(logbuff,"民族读取失败\n");
        return ;
    }
    rlen=rlen*2;
    //strncpy(nation,recvbuff,(rlen-4));
    recvbuff[rlen-4]='\0';
    char nationchange[2];
    a_hex((unsigned char*)&recvbuff[4],(unsigned char*)nationchange,2);


    strncpy(nation,g_Nation[nationchange[0]],strlen(g_Nation[nationchange[0]]));
    memset(sendbuff,0,64);
    memcpy(sendbuff,"00B20C0005",10);
    st = dc_cpuapdusource_hex(icdev,5,sendbuff,&rlen,recvbuff);
    if(st!=0)
    {
        strcpy(logbuff,"出生地读取失败\n");
        return;
    }
    rlen=rlen*2;
    strncpy(addr,recvbuff,(rlen-4));
    addr[rlen-4]='\0';

    memset(sendbuff,0,64);
    memcpy(sendbuff,"00B20D0006 ",10);
    st = dc_cpuapdusource_hex(icdev,5,sendbuff,&rlen,recvbuff);
    if(st!=0)
    {
        strcpy(logbuff,"出生日期读取失败\n");
        return ;
    }
    rlen=rlen*2;
    strncpy(birthday,&recvbuff[4],(rlen-8));
    birthday[rlen-4]='\0';


    char IDnumchange[128]= "\0";
//    hs_a_hex((unsigned char*)&IDnum[2],(unsigned char*)IDnumchange,2);
    a_hex((unsigned char*)&IDnum[2],(unsigned char*)IDnumchange,2);
    len = IDnumchange[0];
    if (len == 0) {
        ui->Recv_Data->append("读取错误");
        return;
    }
//    hs_a_hex((unsigned char*)&IDnum[4],(unsigned char*)IDnumchange,len * 2);
    a_hex((unsigned char*)&IDnum[4],(unsigned char*)IDnumchange,2*len);
    IDnumchange[len]=0;

    char namechange[128] = "\0";
//    hs_a_hex((unsigned char*)&name[2],(unsigned char*)namechange,2);
    a_hex((unsigned char*)&IDnum[2],(unsigned char*)IDnumchange,2);
    len=namechange[0];
//    hs_a_hex((unsigned char*)&name[4],(unsigned char*)namechange,len * 2);
    a_hex((unsigned char*)&IDnum[4],(unsigned char*)IDnumchange,2*len);
    namechange[len]=0;

//    hs_a_hex((unsigned char*)&nation[4],(unsigned char*)nationchange,2);
    a_hex((unsigned char*)&IDnum[4],(unsigned char*)IDnumchange,2);

//    hs_a_hex((unsigned char*)&sex[4],(unsigned char*)sexchange,2);
    a_hex((unsigned char*)&IDnum[4],(unsigned char*)IDnumchange,2);

//    hs_beep(icdev, 10);
    dc_beep(icdev, 10);
    temp = IDnum;
    ui->Recv_Data->append(u8"身份证号:");
    ui->Recv_Data->append(temp);
    temp = name;
    text = temp.fromLocal8Bit(name, 64);
    ui->Recv_Data->append(u8"名字:");
    ui->Recv_Data->append(text);

    temp = sex;
    text = temp.fromLocal8Bit(sex, 64);
    ui->Recv_Data->append(u8"性别:");
    ui->Recv_Data->append(text);

    temp = nation;
    text = temp.fromLocal8Bit(sex, 64);
    ui->Recv_Data->append(u8"民族:");
    ui->Recv_Data->append(text);

    temp = birthday;
    text = temp.fromLocal8Bit(birthday, 64);
    ui->Recv_Data->append(u8"出生日期:");
    ui->Recv_Data->append(text);

}
