#include "sam.h"
#include "usb.h"
#include "ui_sam.h"
#include <QDebug>

SAM::SAM(QWidget *parent) :
    QWidget(parent),
    ui(new Ui::SAM)
{
    ui->setupUi(this);
}

SAM::~SAM()
{
    delete ui;
}

void SAM::on_radioButton_clicked()
{
    unsigned char len = 0;
    char data_buffer[512] = {0};
    QString temp, text;
    int st = 0;
    dc_exit(icdev);
    icdev = dc_init(100, 115200);
    if ((long long) icdev == -1) {
        ui->Recv_Data->append("plese open driver!");
        return;
    }
//    st = hs_setcpu(icdev, 0x0d);    //设置SAM1 0x0d
    st = dc_setcpu(icdev, 0x0d);
    if (st != 0) {
        ui->Recv_Data->append("SET SAM1 ERROR!!");
        return;
    }
//    st = hs_cpureset_hex(icdev, &len, data_buffer);
    st = dc_cpureset_hex(icdev, &len, data_buffer);
    qDebug() << st << endl;
    if (st != 0) {
        ui->Recv_Data->append("Power-on reset failed");
        return;
    }
    temp = data_buffer;
    ui->Recv_Data->append(temp);
//    hs_beep(icdev,10);
    dc_beep(icdev, 10);
}


void SAM::on_radioButton_2_clicked()
{  
    unsigned char len = 0;
    char data_buffer[512] = {0};
    QString temp, text;
    int st = 0;
    dc_exit(icdev);
    icdev = dc_init(100, 115200);
    if ((long long) icdev == -1) {
        ui->Recv_Data->append("plese open driver!");
        return;
    }
//    st = hs_setcpu(icdev, 0x0e);    //设置SAM2 0x0e
    st = dc_setcpu(icdev, 0x0e);
    qDebug() << st << endl;
    if (st != 0) {
        ui->Recv_Data->append("SET SAM2 ERROR!!");
        return;
    }

//    st = hs_cpureset_hex(icdev, &len, data_buffer);
    st = dc_cpureset_hex(icdev, &len, data_buffer);
    if (st != 0) {
        ui->Recv_Data->append("Power-on reset failed");
        return;
    }
    temp = data_buffer;
    ui->Recv_Data->append(temp);
//    hs_beep(icdev,10);
    dc_beep(icdev, 10);
}


void SAM::on_radioButton_3_clicked()
{
    unsigned char len = 0;
    char data_buffer[512] = {0};
    QString temp, text;
    int st = 0;
    dc_exit(icdev);
    icdev = dc_init(100, 115200);

    if ((long long) icdev == -1) {
        ui->Recv_Data->append("plese open driver!");
        return;
    }
//    st = hs_setcpu(icdev, 0x0f);    //设置SAM3 0x0f
    st = dc_setcpu(icdev, 0x0f);
    if (st != 0) {
        ui->Recv_Data->append("SET SAM3 ERROR!!");
        return;
    }

//    st = hs_cpureset_hex(icdev, &le   n, data_buffer);
    st = dc_cpureset_hex(icdev, &len, data_buffer);
    if (st != 0) {
        ui->Recv_Data->append("Power-on reset failed");
        return;
    }
    temp = data_buffer;
    ui->Recv_Data->append(temp);
//    hs_beep(icdev,10);
    dc_beep(icdev, 10);
}


void SAM::on_pushButton_clicked()
{
     ui->Recv_Data->clear();
}

