﻿#include "usb.h"
#include "ui_usb.h"
#include <QMessageBox>
#include <QString>
USB::USB(QWidget *parent) :
    QWidget(parent),
    ui(new Ui::USB)
{
    ui->setupUi(this);
}

USB::~USB()
{
    delete ui;
}

void USB::on_pushButton_clicked()
{
    int driver;
    QString boundrate, temp;
    QMessageBox message;
    long bdrate;
    if ((long long)icdev > 0) {
        this->close();
        return;
    }
    driver = ui->driver->currentIndex();
    boundrate = ui->Boundrate->currentText();
    bdrate = boundrate.toLong();
    if(driver == 0) {
//        icdev = hs_init(100, bdrate);
        icdev = dc_init(100, bdrate);
        if ((long long)icdev < 0) {
            message.information(this,"提示信息","com init error");
            return;
        }
    } else {
//        icdev = hs_init(driver, bdrate);
        icdev = dc_init(driver, bdrate);
        if ((long long)icdev < 0) {
            message.information(this,"提示信息","com init error");
            return;
        }
    }
//    hs_beep(icdev, 20);
    icdev = dc_beep(icdev, 20);
    printf("icdev = %d\n", icdev);
    this->close();
}


void USB::on_pushButton_2_clicked()
{
    int i = 0;
    QString boundrate, temp;
    QMessageBox message;
    long bdrate;
    boundrate = ui->Boundrate->currentText();
    bdrate = boundrate.toLong();
    while ((long long)icdev < 0 && i < 100) {
//        icdev = hs_init(i++, bdrate);
        icdev = dc_init(i++, bdrate);
    }
    if ((long long)icdev > 0) {
//        hs_beep(icdev, 20);
        icdev = dc_beep(icdev, 20);
        temp = QString::number(i - 1);
        ui->lineEdit->setText("COM" + temp);
    }
    else {
        ui->lineEdit->setText("There are no ports available");
    }
}


void USB::on_pushButton_3_clicked()
{
    this->close();
}

