#include "password.h"
#include "ui_password.h"
#include "usb.h"
#include <QMessageBox>
password::password(QWidget *parent) :
    QWidget(parent),
    ui(new Ui::password)
{
    ui->setupUi(this);
}

password::~password()
{
    delete ui;
}

void password::on_change_clicked()
{
    int sector, st; //存放扇区
    int choose; //存放第几套密码，AorB
    QString text;
    QByteArray text_a;
    char *password;

    sector = ui->sector->currentIndex();
    //number = ui->Numder->currentIndex();
    choose = ui->password_2->currentIndex();
    text = ui->in_password->text();
    text_a = text.toLatin1();
    password = text_a.data();
    if (password == NULL) {
        QMessageBox::information(this, u8"提示信息", u8"输入密码");
        return;
    }
    switch(choose) {
    case 0 :
        /*第一套A密码*/
//        st = hs_load_key_hex(icdev, 0, sector, password);
        st = dc_load_key_hex(icdev, 0, sector, password);
        if (st != 0) {
            QMessageBox::information(this, u8"提示信息", u8"装载密码失败");
            return;
        }
//        hs_beep(icdev, 10);
        dc_beep(icdev, 10);
        break;       
    case 1 :
        /*第一套B密码*/
//        st = hs_load_key_hex(icdev, 4, sector, password);
        st = dc_load_key_hex(icdev, 4, sector, password);
        if (st != 0) {
            QMessageBox::information(this, u8"提示信息", u8"装载密码失败");
            return;
        }
//        hs_beep(icdev, 10);
        dc_beep(icdev, 10);
        break;
#if 0
    case 2 :
        switch (choose) {
        case 0:
            /*第三套A密码*/
            st = hs_load_key_hex(icdev, 3, sector, password);
            if (st != 0) {
                QMessageBox::information(this, u8"提示信息", u8"装载密码失败");
                return;
            }
            hs_beep(icdev, 10);
            break;
        case 1:
            /*第三套B密码*/
            st = hs_load_key_hex(icdev, 6, sector, password);
            if (st != 0) {
                QMessageBox::information(this, u8"提示信息", u8"装载密码失败");
                return;
            }
            hs_beep(icdev, 10);
            break;
        }
        break;
#endif
    }
    this->close();
}




void password::on_pushButton_clicked()
{
    int sector = 0, st;
    int choose;
    char password[15] = "\0";

    memcpy(password, "FFFFFFFFFFFF", 12);
   // number = ui->Numder->currentIndex();
    choose = ui->password_2->currentIndex();
    switch(choose) {
    case 0:
        while(sector < 16) {
//            st = hs_load_key_hex(icdev, 0, sector++, password);
            st = dc_load_key_hex(icdev, 0, sector++, password);
            if (st != 0){
                QMessageBox::information(this, u8"提示信息", u8"装载密码失败");
                return;
            }
        }
//        hs_beep(icdev, 10);
        dc_beep(icdev, 10);
        break;
    case 1:
        while(sector < 16) {
//            st = hs_load_key_hex(icdev, 4, sector++, password);
            st = dc_load_key_hex(icdev, 4, sector++, password);
            if (st != 0){
                QMessageBox::information(this, u8"提示信息", u8"装载密码失败");
                return;
            }
        }
//        hs_beep(icdev, 10);
        dc_beep(icdev, 10);
        break;
    }
    this->close();
}
#if 0
    case 1:
        switch (choose) {
        case 0:
            while(sector < 16) {
                st = hs_load_key_hex(icdev, 1, sector++, password);
                if (st != 0){
                    QMessageBox::information(this, u8"提示信息", u8"装载密码失败");
                    return;
                }
            }
            hs_beep(icdev, 10);
            break;
        case 1:
            while(sector < 16) {
                st = hs_load_key_hex(icdev, 5, sector++, password);
                if (st != 0){
                    QMessageBox::information(this, u8"提示信息", u8"装载密码失败");
                    return;
                }
            }
            hs_beep(icdev, 10);
            break;
        }
        break;
    case 2:
        switch (choose) {
        case 0:
            while(sector < 16) {
                st = hs_load_key_hex(icdev, 2, sector++, password);
                if (st != 0){
                    QMessageBox::information(this, u8"提示信息", u8"装载密码失败");
                    return;
                }
            }
            hs_beep(icdev, 10);
            break;
        case 1:
            while(sector < 16) {
                st = hs_load_key_hex(icdev, 6, sector++, password);
                if (st != 0){
                    QMessageBox::information(this, u8"提示信息", u8"装载密码失败");
                    return;
                }
            }
            hs_beep(icdev, 10);
            break;
        }
        break;
    }
#endif


    void password::on_pushButton_2_clicked()
    {
        int sector = 0, st;
        int choose;
        char password[15] = "\0";

        memcpy(password, "A0A1A2A3A4A5", 12);
       // number = ui->Numder->currentIndex();
        choose = ui->password_2->currentIndex();
        switch(choose) {
        case 0:
            while(sector < 16) {
//                st = hs_load_key_hex(icdev, 0, sector++, password);
                st = dc_load_key_hex(icdev, 0, sector++, password);
                if (st != 0){
                    QMessageBox::information(this, u8"提示信息", u8"装载密码失败");
                    return;
                }
            }
//            hs_beep(icdev, 10);
            dc_beep(icdev, 10);
            break;
        case 1:
            while(sector < 16) {
//                st = hs_load_key_hex(icdev, 4, sector++, password);
                st = dc_load_key_hex(icdev, 4, sector++, password);
                if (st != 0){
                    QMessageBox::information(this, u8"提示信息", u8"装载密码失败");
                    return;
                }
            }
//            hs_beep(icdev, 10);
            dc_beep(icdev, 10);
            break;
        }
        this->close();
    }

#if 0
        }

        case 0:
            switch (choose) {
            case 0:
                while(sector < 16) {
                    st = hs_load_key_hex(icdev, 0, sector++, password);
                    if (st != 0){
                        QMessageBox::information(this, u8"提示信息", u8"装载密码失败");
                        return;
                    }
                }
                hs_beep(icdev, 10);
            case 1:
                while(sector < 16) {
                    st = hs_load_key_hex(icdev, 4, sector++, password);
                    if (st != 0){
                        QMessageBox::information(this, u8"提示信息", u8"装载密码失败");
                        return;
                    }
                }
                hs_beep(icdev, 10);
                break;
            }
            break;
        case 1:
            switch (choose) {
            case 0:
                while(sector < 16) {
                    st = hs_load_key_hex(icdev, 1, sector++, password);
                    if (st != 0){
                        QMessageBox::information(this, u8"提示信息", u8"装载密码失败");
                        return;
                    }
                }
                hs_beep(icdev, 10);
                break;
            case 1:
                while(sector < 16) {
                    st = hs_load_key_hex(icdev, 5, sector++, password);
                    if (st != 0){
                        QMessageBox::information(this, u8"提示信息", u8"装载密码失败");
                        return;
                    }
                }
                hs_beep(icdev, 10);
                break;
            }
            break;
        case 2:
            switch (choose) {
            case 0:
                while(sector < 16) {
                    st = hs_load_key_hex(icdev, 2, sector++, password);
                    if (st != 0){
                        QMessageBox::information(this, u8"提示信息", u8"装载密码失败");
                        return;
                    }
                }
                hs_beep(icdev, 10);
                break;
            case 1:
                while(sector < 16) {
                    st = hs_load_key_hex(icdev, 6, sector++, password);
                    if (st != 0){
                        QMessageBox::information(this, u8"提示信息", u8"装载密码失败");
                        return;
                    }
                }
                hs_beep(icdev, 10);
                break;
            }
            break;
#endif

    void password::on_pushButton_3_clicked()
    {
        int sector = 0, st;
        int choose;
        char password[15] = "\0";

        memcpy(password, "B0B1B2B3B4B5", 12);
        //number = ui->Numder->currentIndex();
        choose = ui->password_2->currentIndex();
        switch(choose) {
        case 0:
            while(sector < 16) {
//                st = hs_load_key_hex(icdev, 0, sector++, password);
                st = dc_load_key_hex(icdev, 0, sector++, password);
                if (st != 0){
                    QMessageBox::information(this, u8"提示信息", u8"装载密码失败");
                    return;
                }
            }
//            hs_beep(icdev, 10);
            dc_beep(icdev, 10);
            break;
        case 1:
            while(sector < 16) {
//                st = hs_load_key_hex(icdev, 4, sector++, password);
                st = dc_load_key_hex(icdev, 4, sector++, password);
                if (st != 0){
                    QMessageBox::information(this, u8"提示信息", u8"装载密码失败");
                    return;
                }
            }
//            hs_beep(icdev, 10);
            dc_beep(icdev, 10);
            break;
        }
        this->close();
    }

#if 0
        case 0:
            switch (choose) {
            case 0:
                while(sector < 16) {
                    st = hs_load_key_hex(icdev, 0, sector++, password);
                    if (st != 0){
                        QMessageBox::information(this, u8"提示信息", u8"装载密码失败");
                        return;
                    }
                }
                hs_beep(icdev, 10);
            case 1:
                while(sector < 16) {
                    st = hs_load_key_hex(icdev, 4, sector++, password);
                    if (st != 0){
                        QMessageBox::information(this, u8"提示信息", u8"装载密码失败");
                        return;
                    }
                }
                hs_beep(icdev, 10);
                break;
            }
            break;
        case 1:
            switch (choose) {
            case 0:
                while(sector < 16) {
                    st = hs_load_key_hex(icdev, 1, sector++, password);
                    if (st != 0){
                        QMessageBox::information(this, u8"提示信息", u8"装载密码失败");
                        return;
                    }
                }
                hs_beep(icdev, 10);
                break;
            case 1:
                while(sector < 16) {
                    st = hs_load_key_hex(icdev, 5, sector++, password);
                    if (st != 0){
                        QMessageBox::information(this, u8"提示信息", u8"装载密码失败");
                        return;
                    }
                }
                hs_beep(icdev, 10);
                break;
            }
            break;
        case 2:
            switch (choose) {
            case 0:
                while(sector < 16) {
                    st = hs_load_key_hex(icdev, 2, sector++, password);
                    if (st != 0){
                        QMessageBox::information(this, u8"提示信息", u8"装载密码失败");
                        return;
                    }
                }
                hs_beep(icdev, 10);
                break;
            case 1:
                while(sector < 16) {
                    st = hs_load_key_hex(icdev, 6, sector++, password);
                    if (st != 0){
                        QMessageBox::information(this, u8"提示信息", u8"装载密码失败");
                        return;
                    }
                }
                hs_beep(icdev, 10);
                break;
            }
            break;
        }
    }
#endif
